n, q, k = map(int, input().split())
p = list(map(int, input().split()))
sum = [0] * (n + 1)
for i in range(q):
    l, r = map(int, input().split())
    sum[l - 1] += 1
    sum[r] -= 1
for i in range(1, n):
    sum[i] += sum[i - 1]
delays = [(p[i], i + 1) for i in range(n)]
delays.sort(key=lambda x: x[0])
result = delays[k - 1][1]
print(result)